
#include <bur/plctypes.h>

#ifdef _DEFAULT_INCLUDES
	#include <AsDefault.h>
#endif

unsigned long myCallback(UserData_typ* data, jsmn_callback_data* callbackData) {
	if(callbackData->Size == 0) { // TODO: Why this line

		if(brsstrcmp(callbackData->Structure[1], "station") == 0) { // Check if Key is "station"
			data->station = brsatoi(callbackData->Value); // Convert value from string to Integer
		}
		else if(brsstrcmp(callbackData->Structure[1], "status") == 0) { // Check if Key is "status"
			brsstrcpy(data->status, callbackData->Value);
		}
		else if(brsstrcmp(callbackData->Structure[1], "jobId") == 0) { // Check if Key is "jobId"
			data->jobId = brsatoi(callbackData->Value); // Convert value from string to Integer
		}
	}

	return 0; // No errors
}


void _CYCLIC ProgramCyclic(void)
{
	if(parsePacket) {
		// JSON packet populated in pJson
		parseStatus = JsmnParse((UDINT)&parser, json, brsstrlen(json), (UDINT)&tokens, sizeof(tokens)/sizeof(tokens[0]));

		if(parseStatus >= 0) { // Check that no errors occurred
			stationInfo[myData.station].jobId = myData.jobId;
			brsstrcpy(stationInfo[myData.station].status, myData.status);
		}
	
		// Re-Initialize parser object
		JsmnInit(&parser);
		
		// Reset command
		parsePacket = 0;
	}
}
